import paho.mqtt.client as PahoMQTT
import json
import time

def config_extract():
	configurations = {}
	"""Open and extract all the MQTT config"""
	try:
		with open(confFilename, 'r') as f:
			configurations = json.load(f)
	except FileNotFoundError as e:
		raise(e)

		return configurations


class Subscriber:
		def __init__(self, configFile, name):
			f_conf=open(configFile)
			init_conf=json.load(f_conf)
			f_conf.close()
			self._paho_mqtt=PahoMQTT.Client(name,False)
			self._paho_mqtt.on_connect=self.OnConnect
			self._paho_mqtt.on_message=self.MessageReceived
			self.broker=init_conf["mqtt"]["brokerID"]
			self.port=init_conf["mqtt"]["brokerPort"]
			self.name=name
			self.logging=logging
			

		def start (self, topic):
			#manage connection to broker
			self._paho_mqtt.connect(self.broker, self.port)			

			self._paho_mqtt.loop_start()
			# subscribe for a topic
			for elem in topic:
				self._paho_mqtt.subscribe(elem[0],elem[1])
			print("Subscribed topic by {}:  {}".format(self.name,topic))
			

		def stop (self):
			self._paho_mqtt.unsubscribe(topic)
			self._paho_mqtt.loop_stop()
			self._paho_mqtt.disconnect()

		def OnConnect (self, paho_mqtt, userdata, flags, rc):
			print("Subscriber connected to %s with result code: %d" % (self.broker, rc))
			#print ("Subscriber connected to %s with result code: %d" % (self.broker, rc))

		def MessageReceived (self, paho_mqtt , userdata, msg):
			# A new message is received
			print("New message received")
			print("Topic:<" + msg.topic+">, QoS: <"+str(msg.qos)+"> Message: <"+str(msg.payload) + ">")
			#print ("Topic:'" + msg.topic+"', QoS: '"+str(msg.qos)+"' Message: '"+str(msg.payload) + "'")
			#global output
			if "BLE/connect" in msg.topic:
				#proc=subprocess.Popen(["python","DeviceAgent.py"], stdout=subprocess.PIPE, stderr=subprocess.PIPE, stdin=subprocess.PIPE, text=True)
				data_in=str(msg.payload)
				print(data_in)
				print("BLE connection forced to:  {}".format(data_in))
				#self.pipein.send(["connect",data_in])	#["connect", '{"macaddr": "18:15:DA:25:45"}']
				
if __name__ == '__main__':
	
	sub = Subscriber("MQTT-conf.json","NVT3-sub")
	sub.start(["/prova/test",0])

		while True:
			time.sleep(10)